VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsTools"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Function AppVersion() As String
 'Purpose: Getting the version numer easily...
    
    AppVersion = App.Major & "." & App.Minor & "." & App.Revision
End Function

Public Function AppDir() As String
 'Purpose: Getting the right application path, even when it's located in the root
    
    If Right(App.Path, 1) <> "\" Then
     AppDir = App.Path & "\"
    Else
     AppDir = App.Path
    End If
End Function

Public Function GetFromINI(AppName As String, KeyName As String, FileName As String) As String
 'Purpose: Getting a string from an INI file
 Dim RetStr As String
    
    RetStr = String(255, Chr(0))
    GetFromINI = Left(RetStr, GetPrivateProfileString(AppName, ByVal KeyName, "", RetStr, Len(RetStr), FileName))
End Function

Public Function AddToINI(ByVal FileName As String, ByVal Section As String, ByVal Key As String, ByVal KeyValue As String) As Integer
 'Purpose: Writing a string to an INI file
    
    WritePrivateProfileString Section, Key, KeyValue, FileName
    AddToINI = 1
End Function

Public Function FileAvailable(FileName As String) As Boolean
 'Purpose: Checking if a file really exists
 Dim blnFound As Boolean
    
    blnFound = False 'It's standard false, but just to be sure
    If Len(Dir(FileName)) > 1 Then blnFound = True 'If found, Found = True
    FileAvailable = blnFound
End Function

Public Function ShowFrameRate()
 'Purpose: Calculate framerate, and show it...
 Static I As Integer
 Static tLast As Single
 Static fps As Single
 Static FrameCount
 Dim StrFPS As String
        On Error Resume Next
        If I = 30 Then
        If tLast <> 0 Then fps = 30 / (Timer - tLast)
        tLast = Timer
        I = 0
        End If
        I = I + 1
        
        'Call DDSBack.DrawText(150, 10, ResolutionX & "x" & ResolutionY & "x" & BitsPerPixel & "Frames per Second " + Format$(fps, "#.0"), False)
        StrFPS = Format$(fps, "#")
        ShowNumbers 0, 150, StrFPS
End Function

Public Function DetectCollision(RectA As RECT, RectB As RECT, Optional TypeObject As Long) As Boolean
 'Purpose: Detectinf collision (simple or extended)
 Dim ReturnRect As RECT
 Dim RectAOverlap As RECT, RectBOverlap As RECT
 Dim lWidth As Long, lHeight As Long
 Dim PixelCollision As Boolean
 Dim TempRect As RECT
 Dim Temprect2 As RECT
 Dim I As Integer, J As Integer
 On Error GoTo Errhandler
 If IntersectRect(ReturnRect, RectA, RectB) Then 'if rectanglecollision is detected...
  'Calculate extended
  With RectAOverlap
   .Left = ReturnRect.Left - RectA.Left
   .Right = ReturnRect.Right - RectA.Left
   .Top = ReturnRect.Top - RectA.Top
   .Bottom = ReturnRect.Bottom - RectA.Top
  End With
   DDSBack.SetForeColor vbWhite
    
  With RectBOverlap
   .Left = ReturnRect.Left - RectB.Left
   .Right = ReturnRect.Right - RectB.Left
   .Top = ReturnRect.Top - RectB.Top
   .Bottom = ReturnRect.Bottom - RectB.Top
  End With
  
  lWidth = ReturnRect.Right - ReturnRect.Left - 1
  lHeight = ReturnRect.Bottom - ReturnRect.Top - 1
  
  PixelCollision = False
  
  With Temprect2
   .Left = 106 * Player.Frame
   .Right = .Left + 106
   .Top = 0
   .Bottom = 120
  End With
  
  With TempRect
   .Top = 154 + (Enemies(1).RndVal * 72)
   .Bottom = .Top + 72
   .Left = Enemies(1).Frame * 72
   .Right = .Left + 72
  End With
   
  
  If TypeObject = 1 Then PixelCollision = True 'skip extended if only simple is requested
  'Loop through all pixels for non white parts...
  For I = 0 To lWidth
   For J = 0 To lHeight
    If blnSpritesMask(Temprect2.Left + I, Temprect2.Top + J) = False And blnSpritesMask(TempRect.Left + I, TempRect.Bottom - J) = False Then
     PixelCollision = True 'if found, pixelcollision is true
     Exit For
    End If
    If PixelCollision = True Then Exit For
   Next J
   If PixelCollision = True Then Exit For
  Next I
  
 If PixelCollision = True Then DetectCollision = True 'if pixelcollision is true, then detectcollision is true
End If

Exit Function
Errhandler:
UnloadAll
End
End Function

Public Sub DrawItem(X As Long, ByVal Y As Long, rRender As RECT, ddsSurface As DirectDrawSurface7, Optional Options As CONST_DDBLTFASTFLAGS = DDBLTFAST_SRCCOLORKEY Or DDBLTFAST_WAIT)
 'Purpose: Drawing items, even when they're not completely on the screen (normally they just disappear)
 Dim rTemp As RECT
 Dim lngOutScreen As Long
 
 With rTemp
  .Left = rRender.Left
  .Right = rRender.Right
  .Bottom = rRender.Bottom
  .Top = rRender.Top
 End With
 
 If X < BackGroundX Then 'if too far left
  lngOutScreen = X - BackGroundX
  rTemp.Left = rRender.Left + lngOutScreen
  rTemp.Right = rRender.Right
 End If
 
 If X + (rRender.Right - rRender.Left) > BackGroundX + 640 Then 'if toofar right
  lngOutScreen = (BackGroundX + 640) - X + (rRender.Right - rRender.Left)
  rTemp.Left = rRender.Left
  rTemp.Right = rRender.Right - lngOutScreen
 End If
 
 If Y < 0 Then 'if top out of screen
  lngOutScreen = Y '< 0...
  rTemp.Top = rRender.Top - lngOutScreen
  rTemp.Bottom = rRender.Bottom
  Y = 0
 End If
 
 If Y + (rRender.Bottom - rRender.Top) > GameOptions.ResY Then 'if too far down
  lngOutScreen = Y + (rRender.Bottom - rRender.Top) - GameOptions.ResY
  rTemp.Top = rRender.Top
  rTemp.Bottom = rRender.Bottom - lngOutScreen
 End If
  
 DDSBack.BltFast X, Y, ddsSurface, rTemp, DDBLTFAST_SRCCOLORKEY Or DDBLTFAST_WAIT 'Blit the new rectangle
  
End Sub

Public Sub ShowNumbers(X As Long, Y As Long, strNumbers As String)
 'Purpose: Blitting the numbers from a surface.
 'Requires a string containing numbers, and an x,y position
 
 Dim TempRect As RECT, I As Long, CurrentNumber As String
 With TempRect
  .Top = 300
  .Bottom = 341
 End With
 
 For I = 1 To Len(strNumbers) 'Loop to end of string
  CurrentNumber = Mid(strNumbers, I, 1) 'Get one value
   With TempRect
    .Left = 28 * CurrentNumber '28 * value = good number
    .Right = .Left + 28
   End With
  
   DDSBack.BltFast X + (28 * (I - 1)), Y, ddsSprites, TempRect, DDBLTFAST_SRCCOLORKEY Or DDBLTFAST_WAIT 'blit
 Next I
End Sub
