Attribute VB_Name = "mdlAI"
Option Explicit

Public Sub AddRandomEnemies()
 'Purpose: Add some random enemies...
 Static lngLastEnemyTick As Long
 Dim I As Integer, lngRND As Integer, TheTick As Long
    
    Randomize
    lngRND = Int(((3) - 1 + 1) * Rnd + 1)
    
    For I = 1 To lngRND                                    'Randomize 'Random number's, for every 'for'
        If (DirectX.TickCount - lngLastEnemyTick) > 2000 + (Rnd * 1200) Then
            NewAIGuy                                        'If the lastenemytick has passed, add another one
            lngLastEnemyTick = DirectX.TickCount   'Set lasttick to currenttick
        End If
    Next I
 
End Sub

Public Sub UpdateEnemyStatus(EnemyID As Integer, WeaponID As Integer)
 'Purpose update enemy status (after a weapon hit)
    Enemies(EnemyID).Hits = Enemies(EnemyID).Hits - Weapons(WeaponID).Damage
    
        If Enemies(EnemyID).Hits <= 0 Then 'Enemy is dead, turn him in a burger. (Yummy! :o)
            With Enemies(EnemyID)
                .Enabled = False                        'Disable enemy
                
                Player.Score = Player.Score + 25  '25 points for every dead enemy
                If Player.Score >= Player.NextLifeScore Then 'score reached next life score?
                    Player.Lives = Player.Lives + 1   'Add life...
                    Player.NextLifeScore = Player.NextLifeScore + 2000 'Nextlifescore is currentscore + 2000
                End If
                DSound.PlaySound dsTransForm 'Play transform/hit sound
                AddBurgers .X - 36, .Y - 36      'Add a burger at this position!
                AddStars .X, .Y                      'create 'exploding stars'
            End With
        End If
End Sub

Public Sub NewAIGuy()
 'Purpose: Adding an enemy to the game (they aren't immediatly visible)
 Dim TempRect As RECT, RndVal As Integer
   
    Randomize                                       'Just to keep everything rnd...
    TotalEnemies = TotalEnemies + 1         'Add an enemy
    ReDim Preserve Enemies(TotalEnemies) 'Preserve to keep other enemies
    
    With Enemies(TotalEnemies)
        .RndVal = Int(Rnd * 2) 'Enemy is red or white... 1 or 2...
        .Y = -72 'Start above screen
        .X = Int(((BackGroundX + 568) - BackGroundX + 1) * Rnd + BackGroundX) ' X position min backgroundx, max background + 640 - enemywidth
        If lngStartTime <> Minute(Now) Then
         lngEnemyHits = lngEnemyHits + 1 'if there's difference between starttime and now, increase player strength
         lngStartTime = Minute(Now)                      'This is also the way we make the game harder to play!
        End If
        
        .Hits = lngEnemyHits                  'Starts with 0, so add 1
        .Pattern = Int(Rnd * 5) + 1         'Get a random move pattern
        .Frame = 0                               'Start frame is 0
        .Enabled = True                         'Go!
    End With
  
End Sub

Public Sub ShowEnemies()
 'Purpose: Blitting enemies to backbuffer, after checking for collisions and updating the animation
 Dim TempRect As RECT, I As Integer
 
    For I = 1 To TotalEnemies 'Loop through all enemies
        With Enemies(I)
            If .Enabled = True Then 'If enabled... continue
                With TempRect 'Enemy rect...
                    .Top = 154 + (Enemies(I).RndVal * 72)
                    .Bottom = .Top + 72
                    .Left = Enemies(I).Frame * 72
                    .Right = .Left + 72
                End With
                UpdateEnemyPosition I               'Update enemy position (see below)
                CollisionDetect I                        'Check for collisions
                If (DirectX.TickCount - .LastTick) > 100 Then 'animation is way too fast. Slow it down a bit. 10times/sec
                    .Frame = .Frame + 1              'Move frame right
                    If .Frame = 5 Then .Frame = 0 'If at end of frame, start at 0
                    .LastTick = DirectX.TickCount  'Set lasttick to currenttick
               End If
               Tools.DrawItem .X, .Y, TempRect, ddsSprites 'Draw it using a different function, that checks for parts out of screen
            End If
        End With
    Next I

End Sub

Public Sub UpdateEnemyPosition(EnemyID As Integer)
 'Purpose: Updating the enemy with the defined pattern in NewAIGuy()
 Dim lngCalculation As Long, lngCalculation2 As Long, lngCalculation3 As Long
 
    With Enemies(EnemyID)
        Select Case Enemies(EnemyID).Pattern
            Case 1 'Move down only
                .Y = .Y + 3
            Case 2 ' Move down, and to the left
                .Y = .Y + 3
                .X = .X - 2
            Case 3 ' Move down, and to the right
                .Y = .Y + 3
                .X = .X + 2
            Case 4 'Very slowly to left...
                .Y = .Y + 2
                .X = .X + 1
            Case 5 'Followplayer (Only x)
                .Y = .Y + 3
                If Player.X < .X Then .X = .X - 1
                If Player.X > .X Then .X = .X + 2
        End Select
    
        If .X < BackGroundX Then .X = BackGroundX
        If .X + 72 > (BackGroundX + 640) Then .X = (BackGroundX + 640) - 72
        If .Y > GameOptions.ResY Then .Enabled = False
    End With

End Sub
