Attribute VB_Name = "mdlDeclare"
Option Explicit

'WinAPI Section
    Public Declare Function GetClientRect Lib "user32" (ByVal hwnd As Long, ClientRect As RECT) As Long
    Public Declare Function ClientToScreen Lib "user32" (ByVal hwnd As Long, Point As Any) As Long
    Public Declare Function IntersectRect Lib "user32" (ByRef r As RECT, ByRef r2 As RECT, ByRef r3 As RECT) As Long
    Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (ByRef Destination As Any, ByRef Source As Any, ByVal numbytes As Long)
    Public Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, lpKeyName As Any, ByVal lpDefault As String, ByVal lpRetunedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
    Public Declare Function WritePrivateProfileString& Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal AppName As String, ByVal KeyName As String, ByVal keydefault As String, ByVal FileName As String)
    Public Declare Function SetCursorPos Lib "user32" (ByVal X As Long, ByVal Y As Long) As Long
    Public Declare Function ShowCursor Lib "user32" (ByVal bShow As Long) As Long


'DirectX7 Section
    Public DirectX As DirectX7

'DirectDraw7 Section
    Public ColorKey As DDCOLORKEY
    Public DD As DirectDraw7
    Public DDCaps As DDSCAPS2
    Public DDFXBack As DDBLTFX
    Public DDSBack As DirectDrawSurface7
    Public DDSDFront As DDSURFACEDESC2
    Public DDSFront As DirectDrawSurface7
    Public RectCaps As DDSURFACEDESC2
    Public DirectDrawGUID As String

'Direct3D7 Section
    Public Direct3D As Direct3D7
    Public Device As Direct3DDevice7
    Public Direct3DGUID As String

'DirectInput7 Section
    Public DI As DirectInput
    Public DIKeyBoard As DirectInputDevice
    Public blnKeyboardState(0 To 255) As Byte
    
'DirectSound7 Section
    Public DS As DirectSound
    Public DSPrimaryBuffer As DirectSoundBuffer
    Public DS3DListener As DirectSound3DListener
    Public dsZap As DirectSoundBuffer
    Public dsZap3D As DirectSound3DBuffer
    Public dsMusic As DirectSoundBuffer
    Public dsShoot As DirectSoundBuffer
    Public dsShoot3D As DirectSound3DBuffer
    Public dsTransForm As DirectSoundBuffer
    Public dsEnemyHit As DirectSoundBuffer
    Public dsEnemyHit3D As DirectSound3DBuffer

'Class Section
    Public DDraw As clsDirectDraw
    Public Tools As clsTools
    Public DInput As clsDirectInput
    Public DSound As clsDirectSound
    
'Misc. Section
    Public blnPressEscape As Boolean
    Public BackGroundX As Long
    Public BackGroundY As Long
    Public LastTick As Long
    Public SecRect As RECT                          'Required for scrolling
    Public blnWaitForF1 As Boolean
    Public lngEnemyHits As Long
    Public blnProceed As Boolean
    Public blnSpritesMask() As Boolean
    Public blnWeaponMask() As Boolean
    Public blnWaitForSpace As Boolean
    Public lngStartTime As Long
    Public blnPauzeGame As Boolean
    Public strBuffer As String
    Public lngHighScore As Long                     'Keeps track of high scores
    Public blnHighScoreInput As Boolean



'Type Section
    Public Type typeOptions
        ResX As Long
        ResY As Long
        AlphaStars As Boolean
        AlphaBurgers As Boolean
        Sounds As Boolean
        Music As Boolean
        FrameRate As Boolean
        DDGuid As String
        D3DGuid As String
        BPP As Long
        blnUseHardware As Boolean
    End Type
    Public GameOptions As typeOptions
    
    Public Type typePlayer
         Frame As Long
         Lives As Long
         X As Long
         Y As Long
         LastShock As Long
         LastTime As Long 'used for various
         FlashTime As Long
         Score As Integer
         NextLifeScore As Integer
         Shocks As Long
         Flashes As Long
    End Type
    Public Player As typePlayer

    Public Type typeAI
        Frame As Long
        RndVal As Integer
        Pattern As Long
        Hits As Long
        X As Long
        Y As Long
        Enabled As Boolean
        LastTick As Long
    End Type
    Public Enemies() As typeAI
    Public TotalEnemies As Long

    Public Type typeWeapon
        X As Long
        Y As Long
        Damage As Long
        Enabled As Boolean
    End Type
    Public Weapons() As typeWeapon
    Public TotalWeapons As Long
    
    Public Type typeBurger
        X As Long
        Y As Long
        Frame As Long
        Enabled As Boolean
        LastTick As Long
        Alpha As Single
    End Type
    Public Burgers() As typeBurger
    Public TotalBurgers As Long
    
    Public Type typeStar
        X As Long
        Y As Long
        Enabled As Boolean
        Star As Long 'Defines Star 1-3
        LastTick As Long
        TimeOut As Long
        Pattern As Long
        Alpha As Single
    End Type
    Public Stars() As typeStar
    Public TotalStars As Long
    
    Public Type typeCloud
        X As Long
        Y As Long
        Enabled As Boolean
        Frame As Long
        ShockTick As Long
    End Type
    Public Clouds() As typeCloud
    Public TotalClouds As Long

